microsocial/urls.py
# coding=utf-8
from django.conf import settings
from django.conf.urls import url, include
from django.contrib import admin
from django.contrib.flatpages.views import flatpage
from microsocial import views

urlpatterns = [
    url(r'^admin/', admin.site.urls),

    url(r'^(en/about/)$', flatpage, name='about'),
    url(r'^(en/advertising/)$', flatpage, name='advertising'),
    url(r'^(en/developers/)$', flatpage, name='developers'),
    url(r'^(en/help/)$', flatpage, name='help'),
    url(r'^(en/vacancies/)$', flatpage, name='vacancies'),
    url(r'^(ru/about/)$', flatpage, name='about'),
    url(r'^(ru/advertising/)$', flatpage, name='advertising'),
    url(r'^(ru/developers/)$', flatpage, name='developers'),
    url(r'^(ru/help/)$', flatpage, name='help'),
    url(r'^(ru/vacancies/)$', flatpage, name='vacancies'),
    url(r'^(uk/about/)$', flatpage, name='about'),
    url(r'^(uk/advertising/)$', flatpage, name='advertising'),
    url(r'^(uk/developers/)$', flatpage, name='developers'),
    url(r'^(uk/help/)$', flatpage, name='help'),
    url(r'^(uk/vacancies/)$', flatpage, name='vacancies'),

    url(r'^i18n/', include('django.conf.urls.i18n')),
    url(r'^friends/', include('friends.urls')),
    url(r'', include('user.urls')),
    url(r'^$', views.main, name='main'),
]


if settings.DEBUG:
    from django.conf.urls.static import static
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

user/urls.py
# coding=utf-8
from django.conf.urls import url
from django.contrib.auth.views import logout_then_login
from user import views
from user.views import MessagesView

urlpatterns = [
    url(r'^login/$', views.login_view, name='login'),
    url(r'^logout/$', logout_then_login, name='logout'),
    url(r'^registration/', views.RegistrationView.as_view(), name='registration'),
    url(r'^password-recovery/$', views.PasswordRecoveryView.as_view(), name='pass_recovery'),
    url(r'^password-recovery/(?P<token>.+)/$', views.PasswordRecoveryConfirmView.as_view()),
    url(r'^profile/(?P<user_id>\d+)/$', views.UserProfileView.as_view(), name='profile'),
    url(r'^settings/$', views.MyView.as_view(), name='settings'),
    url(r'^search/', views.SearchView.as_view(), name='search'),
    url(r'^messages/$', MessagesView.as_view(), name='messages'),
    url(r'^messages/(?P<user_id>\d+)/$', MessagesView.as_view(), name='dialog'),
    url(r'^new/$', views.WallView.as_view(), name='wall'),
]

user/models.py
# coding=utf-8
import os
import datetime
from boltons.setutils import IndexedSet
from django.contrib.sites.models import Site
from django.core.mail import send_mail
from django.db import models
from django.db.models import Q
from django.db.models.signals import post_save
from django.dispatch import receiver
from django.utils import timezone
from django.utils.translation import ugettext, ugettext_lazy as _
from django.contrib.auth.models import AbstractBaseUser, BaseUserManager, PermissionsMixin
from user.signals import create_wall_action_friends


class UserManager(BaseUserManager):
    def create_user(self, email, first_name, password=None):
        if not email:
            raise ValueError(ugettext(u'Пользователи должны иметь адрес электронной почты'))
        elif not first_name:
            raise ValueError(ugettext(u'Пользователи должны иметь имя'))
        if User.objects.filter(email=self.normalize_email(email)).exists():
            raise ValueError(ugettext(u'Пользователь с такой электронной почте зарегистрирован'))
        user = self.model(email=self.normalize_email(email), first_name=first_name)
        user.set_password(password)
        user.is_staff = True
        user.save(using=self._db)
        return user

    def create_superuser(self, email, first_name, password):
        user = self.create_user(email, password=password, first_name=first_name)
        user.is_staff = True
        user.is_superuser = True
        user.save(using=self._db)
        return user


class FriendsManager(models.Manager):

    def _get_pk_users(self, user, user_to):
        user_pk = user.pk if isinstance(user, User) else user
        user_to_pk = user_to.pk if isinstance(user_to, User) else user_to
        return int(user_pk), int(user_to_pk)

    def are_friends(self, user, user_to):
        user_pk, friend_pk = self._get_pk_users(user, user_to)
        return User.objects.filter(pk=user_pk, friends=friend_pk).exists()

    def add_friendship(self, user, friend):
        user_pk, friend_pk = self._get_pk_users(user, friend)
        if user_pk != friend_pk:
            user = User.objects.get(pk=user_pk)
            friend = User.objects.get(pk=friend_pk)
            qs = User.objects.filter(pk=friend_pk, application=user_pk)
            if qs.exists():
                user.friends.add(friend)
                create_wall_action_friends.send(None, user=user, friend=friend, action='post_add')
                user.application.remove(friend)
                friend.application.remove(user)
                return True
            user.application.add(friend)
            return False
        return

    def check_application(self, user, friend):
        user_pk, friend_pk = self._get_pk_users(user, friend)
        return User.objects.filter(pk=user_pk, application=friend_pk).exists()

    def del_friendship(self, user, friend):
        user_pk, friend_pk = self._get_pk_users(user, friend)
        usr = User.objects.get(pk=user_pk)
        friend = User.objects.get(pk=friend_pk)
        create_wall_action_friends.send(None, user=user, friend=friend, action='pre_remove')
        usr.friends.remove(friend)

    def del_application(self, user_from, user_to):
        user_pk, user_to_pk = self._get_pk_users(user_from, user_to)
        usr = User.objects.get(pk=user_pk)
        usr.application.remove(user_to_pk)


def avatar_upload_to(instance, filename):
    return os.path.join('img', '{}{}'.format(instance.pk, os.path.splitext(filename)[1]))


class User(AbstractBaseUser, PermissionsMixin):
    MEN = u'M'
    WOMEN = u'W'
    SEX = (
        (MEN, _(u'мужчина')),
        (WOMEN, _(u'женщины')),
        )
    avatar = models.ImageField(_(u'аватар'), upload_to=avatar_upload_to, blank=True)
    email = models.EmailField(_(u'email'), unique=True)
    first_name = models.CharField(_(u'имя'), max_length=150)
    last_name = models.CharField(_(u'фамилия'), max_length=150, blank=True, null=True)
    sex = models.CharField(_(u'пол'), choices=SEX, max_length=1, blank=True, null=True)
    birthday = models.DateField(_(u'день рождения'), blank=True, null=True)
    city = models.CharField(_(u'город'), max_length=50, blank=True, null=True)
    work_place = models.CharField(_(u'место работы'), max_length=100, blank=True, null=True)
    about = models.CharField(_(u'обо мне'), max_length=255, blank=True, null=True)
    interests = models.CharField(_(u'интереси'), max_length=255, blank=True, null=True)
    confirmed_registration = models.BooleanField(_(u'confirmed registration'), default=False)
    is_staff = models.BooleanField(_(u'статус пользователя'), default=False)
    is_active = models.BooleanField(_(u'активный'), default=True)
    date_joined = models.DateTimeField(_(u'дата логирования'), default=timezone.now)
    application = models.ManyToManyField('self', verbose_name=_(u'отправить заявку'), symmetrical=False,
                                         related_name='sent_applications', blank=True)
    friends = models.ManyToManyField('self', verbose_name=_(u'друзья'), blank=True, related_name='+')
    wall = models.ManyToManyField('Wall', verbose_name=_(u'стена'), related_name='+')

    objects = UserManager()
    managers = FriendsManager()

    USERNAME_FIELD = 'email'
    REQUIRED_FIELDS = ('first_name',)

    def get_full_name(self):
        return u'{} {}'.format(self.first_name, self.last_name)

    def get_short_name(self):
        return u'{}'.format(self.email)

    def email_user(self, subject, message, from_email=None, **kwargs):
        return send_mail(subject, message, from_email, [self.email], **kwargs)

    def get_age(self):
        if self.birthday:
            return int((datetime.date.today() - self.birthday).days / 365.2425)


class PostWall(models.Model):
    receiver = models.ForeignKey(User, related_name='post_messages')
    author = models.ForeignKey(User)
    post_data = models.DateTimeField(_(u'дата публикаций'), auto_now_add=True)
    post = models.TextField(_(u'сообщения'), max_length=1000)

    class Meta:
        ordering = ('-post_data',)
        index_together = ('receiver', 'post_data')


class Message(models.Model):
    text = models.TextField(_(u'сообщения'), max_length=1000)
    time_create = models.DateTimeField(_(u'дата публикаций'), auto_now_add=True)

    class Meta:
        ordering = ('-time_create',)


class DialogManager(models.Manager):
    def _get_pk_users(self, user, user_to):
        user_pk = user.pk if isinstance(user, User) else user
        user_to_pk = user_to.pk if isinstance(user_to, User) else user_to
        return int(user_pk), int(user_to_pk)

    def get_list_dialog(self, user):
        user_pk = user.pk if isinstance(user, User) else user
        users_pk = IndexedSet(i if i != user_pk else j for i, j in Dialog.get_dialog.
                              filter(Q(recipient=user_pk) | Q(author=user_pk)).select_related('author', 'recipient').
                              values_list('author_id', 'recipient_id'))
        users_pk -= {user_pk}
        dialog = []
        for pk in users_pk:
            in_user = Dialog.get_dialog.filter(author=pk, recipient=user_pk).select_related('author', 'messages').\
                only('author_id', 'messages__time_create').first()
            out_user = Dialog.get_dialog.filter(author=user_pk, recipient=pk).select_related('recipient', 'messages').\
                only('recipient_id', 'messages__time_create').first()
            if in_user and out_user:
                if (in_user.messages.time_create - out_user.messages.time_create).total_seconds() >= 0:
                    dialog.append(in_user.author_id)
                else:
                    dialog.append(out_user.recipient_id)
            else:
                tmp = getattr(in_user, 'author_id', None) or getattr(out_user, 'recipient_id', None)
                if tmp:
                    dialog.append(tmp)
        return dialog

    def get_messages(self, user, with_user):
        user, with_user = self._get_pk_users(user, with_user)
        messages = Dialog.get_dialog.filter(Q(author=user, recipient=with_user) | Q(author=with_user, recipient=user)).\
            select_related('messages', 'author').order_by('-messages__time_create')
        return messages


class Dialog(models.Model):
    author = models.ForeignKey(User, related_name='authors')
    recipient = models.ForeignKey(User, related_name='recipient_for')
    messages = models.ForeignKey(Message, related_name='messages_re', db_index=True)

    get_dialog = DialogManager()

    class Meta:
        ordering = ('-messages__time_create',)


def get_pk_users(*args):
    res = []
    for value in args:
        if value:
            res.append(value.pk if isinstance(value, User) else int(value))
    return res


class ManagerWall(models.Manager):
    def create_wall(self, action, user1, user2=None, messages=None):
        usr = get_pk_users(user1, user2)
        if len(usr) > 1:
            return Wall.objects.create(user1_id=usr[0], user2_id=usr[1], action=action, messages_wall=messages)
        return Wall.objects.create(user1_id=usr[0], action=action, messages_wall=messages)

    def get_all_pk_friends(self, pk):
        tmp = list(User.objects.filter(pk=pk).prefetch_related('friends').values_list('friends', flat=True))
        tmp.append(pk)
        return tmp

    def get_all_pk_friends_without_dublicate(self, user1, user2):
        usr_pks = get_pk_users(user1, user2)
        frineds1 = set(self.get_all_pk_friends(pk=usr_pks[0]))
        frineds2 = set(self.get_all_pk_friends(pk=usr_pks[1]))
        return frineds1 | frineds2


class Wall(models.Model):
    FRIENDSHIP = u'1'
    NOT_FRIENDSHIP = u'2'
    WROTE = u'3'
    WROTE_OTHER_USER = u'4'

    ACTION_CHOICE = (
        (FRIENDSHIP, _(u'подружились')),
        (NOT_FRIENDSHIP, _(u'разорвали дружбу')),
        (WROTE, _(u'написал на своей стене')),
        (WROTE_OTHER_USER, _(u'написал на стене')),
    )
    user1 = models.ForeignKey(User, related_name='+')

user/templates/user/login.html
{% extends 'root.html' %}

{% load i18n %}

{% block context %}
    <div class="container">
        {% include 'show_messages.html' %}
        <div class="col-md-offset-4 col-md-4">
            <h1 class="text-center">{% trans 'логин'|capfirst %}</h1>
            <form method="post" class="form-horizontal">
                {% csrf_token %}
                    <p><input name="email" type="text" class="form-control" placeholder="{% trans 'email' %}"></p>
                    <p><input name="password" type="password" class="form-control" placeholder="{% trans 'пароль' %}"></p>
                    <p><input type="submit" class="form-control btn btn-primary" value="{% trans 'войти'|capfirst %}"></p>
            </form>
                <div class="text-center">
                    <a href="{% url 'pass_recovery' %}">{% trans 'забыли пароль'|capfirst %}?</a>
                    <a href="{% url 'registration' %}">{% trans 'регистарция'|capfirst %}</a>
                </div>
        </div>
    </div>
{% endblock %}

user/templates/user/messages.html
{% extends 'root.html' %}

{% load i18n microsocial humanize %}

{% block context %}
    <div class="container-fluid">
        <div class="row">
            <div class="col-md-3">
                <h1>{% trans 'сообщения'|capfirst %}</h1>
                <ul style="list-style-type: none">
                    {% for pk in users_pk %}
                        {% for diaglo in dialogs %}
                            {% if pk == diaglo.pk %}
                                <div style="{% if recipient and pk == recipient.pk %}background-color: lightblue{% endif %}">
                                    <li>
                                        <a href="{% url 'dialog' diaglo.pk %}">
                                            <img src="{{ diaglo|get_avatar }}" style="margin: 5px 0" height="100px" width="100px"/>
                                            {{ diaglo.get_full_name }}
                                        </a>
                                    </li>
                                </div>
                            {% endif %}
                        {% endfor %}
                    {% endfor %}
                </ul>
                {% show_paginator dialogs page_arg_name='usr_page' %}
            </div>
            <div class="col-md-offset-2 col-md-7">
                {% if recipient %}
                    {% include 'show_messages.html' %}
                    <p>
                        {% trans 'диалог с'|capfirst %}
                        <a href="{% url 'profile' recipient.pk %}">
                            <img src="{{ recipient|get_avatar }}" height="50px" width="50px"/>
                            {{ recipient.get_full_name }}
                        </a>
                    </p>
                    <form class="form-horizontal" method="post">
                        {% csrf_token %}
                        <div class="form-group">
                            <div class="col-sm-6">
                                {{ form }}
                            </div>
                            <div class="col-sm-offset-1 col-sm-2">
                                <input type="submit" class="form-control btn btn-primary" value="{% trans 'отправить'|capfirst %}">
                            </div>
                        </div>
                    </form>
                    {% for usr_message in usr_messages %}
                        <div class="row" style="margin: 10px 0">
                            <div class="col-md-2">
                                <img src="{{ usr_message.author|get_avatar }}" height="100px" width="100px"/>
                            </div>
                            <div class="col-md-3">
                                <p>
                                    <a href="{% url 'profile' usr_message.author_id %}">{{ usr_message.author.get_full_name }}</a>
                                </p>
                                <span title="{{ usr_message.messages.time_create }}">{{ usr_message.messages.time_create|naturaltime }}</span>
                            </div>
                            <div class="col-md-7">
                                {{ usr_message.messages.text|linebreaksbr }}
                            </div>
                        </div>
                    {% endfor %}
                    {% show_paginator usr_messages page_arg_name='usr_message' %}
                {% endif %}
            </div>
        </div>
    </div>
{% endblock %}

user/templates/user/password_recovery.html
{% extends 'root.html' %}

{% load i18n microsocial %}

{% block context %}
    <div class="container">
        {% include 'show_messages.html' %}
        <div class="col-md-offset-3 col-md-6 text-center">
            {% if change_pass %}
                <h1>{% trans 'восстановление пароля'|capfirst %}</h1>
            {% else %}
                <h1>{% trans 'новый пароль'|capfirst %}</h1>
            {% endif %}
            <form method="post" class="form-horizontal">
                {% csrf_token %}
                {% for field in form %}
                    {% show_form_field_errors field.errors %}
                    <div class="form-group {% if field.errors %}has-error{% endif %}">
                        {{ field }}
                    </div>
                {% endfor %}
                <div class="form-group">
                    <input type="submit" class="form-control btn btn-primary" name="submit" value="
                            {% if change_pass %}{% trans 'востановить пароль'|capfirst %}{% else %}{% trans 'сохранить'|capfirst %}{% endif %}">
                </div>
            </form>
            <a href="{% url 'login' %}">{% trans 'авторизация'|capfirst %}</a>
        </div>
    </div>
{% endblock %}

user/templates/user/profile.html
{% extends 'root.html' %}

{% load i18n microsocial humanize %}

{% block context %}
    <div class="container-fluid">
        <div class="row">
            <div class="col-md-offset-1 col-md-2 text-center">
                <img src="{{ profile_user|get_avatar }}" width="300px" height="300px"/>
                {% if profile_user.pk == user.pk %}
                    <p style="margin-top: 10px"><a href="{% url 'settings' %}">{% trans 'настройки'|capfirst %}</a></p>
                {% else %}
                    <form method="post" action="{% url 'action_users' %}">
                        {% csrf_token %}
                        {% if are_friends %}
                            <input type="hidden" name="remove_friend" value="{{ profile_user.pk }}">
                            <input type="submit" name="{{ 'remove_friend_'|add:profile_user.pk }}"
                                   value="{% trans 'удалить из друзей'|capfirst %}">
                        {% else %}
                            <input type="hidden" name="add_friend" value="{{ profile_user.pk }}">
                            <input type="submit" class="btn btn-primary" style="padding: 10px; margin: 10px"  name="{{ 'add_friend_'|add:profile_user.pk }}"
                                   value="{% trans 'добавить в друзья'|capfirst %}">
                        {% endif %}
                    </form>
                    <p><a href="{% url 'dialog' profile_user.pk %}">{% trans 'написать сообщения'|capfirst %}</a></p>
                {% endif %}
            </div>
            <div class="col-md-offset-1 col-md-8">
                {% include 'show_messages.html' %}
                <h1>{{ profile_user.get_full_name }}</h1>
                <table style="border-collapse: inherit; border-spacing: 30px 5px;">
                    {% if profile_user.sex %}
                        <tr>
                            <td>{% trans 'пол'|capfirst %}:</td>
                            <td>{{ profile_user.get_sex_display }}</td>
                        </tr>
                    {% endif %}
                    {% if profile_user.birthday %}
                        <tr>
                            <td>{% trans 'дата рождения'|capfirst %}:
                            <td>{{ profile_user.birthday }}</td>
                        </tr>
                    {% endif %}
                    {% if profile_user.city %}
                        <tr>
                            <td>{% trans 'город'|capfirst %}:</td>
                            <td>{{ profile_user.city }}</td>
                        </tr>
                    {% endif %}
                    {% if profile_user.work_place %}
                        <tr>
                            <td>{% trans 'место работы'|capfirst %}:</td>
                            <td>{{ profile_user.work_place }}</td>
                        </tr>
                    {% endif %}
                    {% if profile_user.about %}
                        <tr>
                            <td>{% trans 'о себе'|capfirst %}:</td>
                            <td>{{ profile_user.about }}</td>
                        </tr>
                    {% endif %}
                    {% if profile_user.interests %}
                        <tr>
                            <td>{% trans 'интересы'|capfirst %}:</td>
                            <td>{{ profile_user.interests }}</td>
                        </tr>
                    {% endif %}
                </table>
                <form class="form" method="post">
                    {% csrf_token %}
                    {% for field in form %}
                        {% show_form_field_errors field.errors %}
                        <div class="form-group {% if field.errors %}has-error{% endif %}">
                            {{ field }}
                        </div>
                    {% endfor %}
                    <div class="col-md-12">
                        <input type="submit" class="form-control btn btn-primary"
                               value="{% trans 'опубликовать'|capfirst %}">
                    </div>
                </form>
                {% for post in post_wall %}
                    <div style="margin-top: 20px; border: 1px #666; padding: 10px;">
                        <div class="row">
                            <div class="col-md-2">
                                <img src="{{ post.author|get_avatar }}" height="100px" width="100px"/>
                            </div>
                            <div class="col-md-8">
                                <a href="{% url 'profile' post.author_id %}">{{ post.author.get_full_name }}</a>
                                <span title="{{ post.post_data }}">{{ post.post_data|naturaltime }}</span>
                                <p>{{ post.post|linebreaksbr }}</p>
                            </div>
                        </div>
                    </div>
                {% endfor %}
            </div>
            {% show_paginator post_wall %}
        </div>
    </div>
{% endblock %}

user/templates/user/registration.html
{% extends 'root.html' %}

{% load i18n microsocial %}

{% block context %}
    <div class="container">
        {% include 'show_messages.html' %}
        <div class="col-md-offset-4 col-md-4 text-center">
            <h1>{% trans 'регистрация'|capfirst %}</h1>
            <form method="post" class="form-horizontal">
                {% csrf_token %}
                {% for field in form %}
                    {% show_form_field_errors field.errors %}
                    <div class="form-group {% if field.errors %}has-error{% endif %}">
                        {{ field }}
                    </div>
                {% endfor %}
                <div class="form-group">
                     <input type="submit" name="submit" class="form-control btn btn-primary" value="{% trans 'зарегистрироваться'|capfirst %}">
                </div>
            </form>
            <a href="{% url 'login' %}">{% trans 'авторизация'|capfirst %}</a>
        </div>
    </div>
{% endblock %}

user/templates/user/search.html
{% extends 'root.html' %}

{% load i18n microsocial %}

{% block context %}
    <h1 class="text-center">{% trans 'поиск людей'|capfirst %}</h1>

        <div class="row">
        <div class="col-sm-5">
            <form class="form-horizontal">
                <div class="form-group">
                    <label for="{{ form.names.id_for_label }}" class="col-md-5 control-label">
                        {{ form.names.label|capfirst }}:
                    </label>
                    <div class="col-md-7">
                        {{ form.names }}
                    </div>
                </div>
                <div class="form-group">
                    <label for="{{ form.sex.id_for_label }}" class="col-md-5 control-label">
                        {{ form.sex.label|capfirst }}:
                    </label>
                    <div class="col-md-7">
                        {{ form.sex }}
                    </div>
                </div>
                <div class="form-group">
                    <label for="{{ form.start_year.id_for_label }}" class="col-md-5 control-label">
                        {% trans 'год рождения'|capfirst %}:
                    </label>
                    <div class="col-md-7">
                        <div class="row">
                            <div class="col-xs-6">
                                {{ form.start_year }}
                            </div>
                            <div class="col-xs-6">
                                {{ form.end_year }}
                            </div>
                        </div>
                    </div>
                </div>
                <div class="form-group">
                    <label for="{{ form.city.id_for_label }}" class="col-md-5 control-label">
                        {{ form.city.label|capfirst }}:
                    </label>
                    <div class="col-md-7">
                        {{ form.city }}
                    </div>
                </div>
                <div class="form-group">
                    <label for="{{ form.work_place.id_for_label }}" class="col-md-5 control-label">
                        {{ form.work_place.label|capfirst }}:
                    </label>
                    <div class="col-md-7">
                        {{ form.work_place }}
                    </div>
                </div>
                <div class="form-group">
                    <label for="{{ form.about.id_for_label }}" class="col-md-5 control-label">
                        {{ form.about.label|capfirst }}:
                    </label>
                    <div class="col-md-7">
                        {{ form.about }}
                    </div>
                </div>
                <div class="form-group">
                    <label for="{{ form.interests.id_for_label }}" class="col-md-5 control-label">
                        {{ form.interests.label|capfirst }}:
                    </label>
                    <div class="col-md-7">
                        {{ form.interests }}
                    </div>
                </div>
                <div class="form-group">
                    <div class="col-sm-offset-5 col-md-7">
                        <button type="submit" class="btn btn-primary">{% trans 'искать'|capfirst %}</button>
                    </div>
                </div>
            </form>
        </div>
        <div class="col-sm-7">
            {% include 'show_messages.html' %}
            {% for usr in users %}
                <div class="row" style="margin: 10px">
                    <div class="col-md-2">
                        <img src="{{ usr|get_avatar }}" height="100px" width="100px"/>
                    </div>
                    <div class="col-md-10">
                        <a href="{% url 'profile' usr.pk %}">{{ usr.get_full_name }}</a>
                        {% with age=usr.get_age %}
                            {% if age %}
                                <p>{% blocktrans %}{{ age }} лет{% endblocktrans %}</p>
                            {% endif %}
                        {% endwith %}
                        {% if usr.city %}
                            <p>{{ usr.city }}</p>
                        {% endif %}
                    </div>
                </div>
            {% endfor %}
            {% show_paginator users request_get=get %}
        </div>
    </div>
{% endblock %}

user/templates/user/send_email.html
{% extends 'root.html' %}

{% load i18n %}

{% block context %}
    <div class="content_form">
        <h1 class="text-center">{{ mess|capfirst }}</h1>
    </div>
{% endblock %}

user/templates/user/wall.html
{% extends 'root.html' %}

{% load static i18n humanize microsocial %}

{% block context %}
    <div class="container-fluid">
        <h1>{% trans 'новости'|capfirst %}</h1>
        {% for item in wall %}
            <div class="row">
                <div class="col-md-12 text-justify">
                    <img src="{{ item.user1|get_avatar }}" height="100px" width="100px"/>
                    <a href="{% url 'profile' item.user1_id %}">{{ item.user1.get_full_name }}</a>
                    {% if item.action == friendship or item.action == not_friendship %}
                        {% trans 'и' %}
                    {% else %}
                        {{ item.get_action_display }}
                    {% endif %}
                    {% if item.user2 %}
                        <img src="{{ item.user2|get_avatar }}" height="100px" width="100px"/>
                        <a href="{% url 'profile' item.user2_id %}">{{ item.user2.get_full_name }}</a>
                    {% endif %}
                    {% if item.action == friendship or item.action == not_friendship %}
                        {{ item.get_action_display }}
                    {% endif %}
                    <span title="{{ item.created }}">{{ item.created|naturaltime }}</span>
                    {% if item.messages_wall %}
                        <p style="margin: 10px 0">{{ item.messages_wall.post|linebreaksbr }}</p>
                    {% endif %}
                </div>
                <hr>
            </div>
        {% endfor %}
     {% show_paginator wall %}
    </div>
{% endblock %}